<template>
    <div>
        <el-form
            :model="queryParams"
            ref="queryForm"
            size="small"
            :rules="queryRules"
            :inline="true"
            v-show="showSearch"
            label-width="100px"
        >
            <el-row>
                <el-form-item label="退料单位" prop="unitId">
                    <el-select
                        v-model="queryParams.unitId"
                        clearable
                        filterable
                        @change="GetProData"
                        style="width: 240px"
                        placeholder="请选择"
                        :disabled="isEdit"
                    >
                        <el-option
                            v-for="item in unitList"
                            :key="item.id"
                            :label="item.name"
                            :value="item.id"
                        >
                        </el-option>
                    </el-select>
                </el-form-item>
                <el-form-item label="退料工程" prop="proId">
                    <el-select
                        v-model="queryParams.proId"
                        clearable
                        filterable
                        @change="GetUnitData"
                        style="width: 240px"
                        placeholder="请选择"
                        :disabled="isEdit"
                    >
                        <el-option
                            v-for="item in proList"
                            :key="item.id"
                            :label="item.name"
                            :value="item.id"
                        >
                        </el-option>
                    </el-select>
                </el-form-item>
                <el-form-item label="协议号" prop="agreementCode">
                    <el-input
                        v-model="queryParams.agreementCode"
                        disabled
                        style="width: 240px"
                    ></el-input>
                </el-form-item>
                <el-form-item label="物品类型" prop="status">
                    <el-cascader
                        placeholder="请输入物品类型"
                        :options="deviceTypeTree"
                        :props="deviceTypeTreeProps"
                        v-model="deviceType"
                        @change="deviceTypeChange"
                        ref="deviceTypeCascader"
                        filterable
                        style="width: 240px"
                    ></el-cascader>
                </el-form-item>
                <el-form-item label="退料人" prop="backPerson">
                    <el-input
                        v-model="queryParams.backPerson"
                        placeholder="请输入退料人"
                        clearable
                        @keyup.enter.native="handleQuery"
                        style="width: 240px"
                    />
                </el-form-item>
                <el-form-item label="退料时间" prop="backTime">
                    <el-date-picker
                        v-model="queryParams.backTime"
                        type="date"
                        value-format="yyyy-MM-dd"
                        placeholder="选择时间"
                        style="width: 240px"
                    >
                    </el-date-picker>
                </el-form-item>
                <el-form-item label="退料人电话" prop="phone">
                    <el-input
                        v-model="queryParams.phone"
                        placeholder="请输入退料人电话"
                        clearable
                        style="width: 240px"
                        :maxlength="11"
                    />
                </el-form-item>
                <el-form-item label="备注" prop="roleName">
                    <el-input
                        v-model="queryParams.remark"
                        placeholder="请输入备注"
                        clearable
                        rows="1"
                        type="textarea"
                        style="width: 240px"
                        @keyup.enter.native="handleQuery"
                    />
                </el-form-item>
            </el-row>
            <el-row> </el-row>
        </el-form>

        <el-row :gutter="10" class="mb8">
            <!-- <el-col :span="1.5">
                <el-button
                    type="success"
                    plain
                    icon="el-icon-back"
                    size="mini"
                    @click="handleBack"
                    >退料管理</el-button
                >
            </el-col> -->
            <el-col :span="1.5">
                <el-button
                    type="primary"
                    plain
                    icon="el-icon-plus"
                    size="mini"
                    @click="handleAdd"
                    >保存</el-button
                >
            </el-col>

            <el-col :span="1.5">
                <!-- <el-button
            type="warning"
            plain
            icon="el-icon-download"
            size="mini"
            @click="handleExport"
            v-hasPermi="['system:role:export']"
          >导出</el-button> -->
            </el-col>
        </el-row>
        <el-table
            v-loading="loading"
            :data="leaseApplyDetails"
            @selection-change="handleSelectionChange"
        >
            <el-table-column
                type="selection"
                min-width="55"
                align="center"
                :selectable="selectable"
            />
            <el-table-column label="序号" type="index" min-width="120" />
            <el-table-column
                label="类型名称"
                prop="typeName"
                min-width="200"
                :show-overflow-tooltip="true"
            />
            <el-table-column
                label="规格型号"
                prop="typeCode"
                min-width="200"
                :show-overflow-tooltip="true"
            />
            <el-table-column
                label="计量单位"
                prop="unitNames"
                min-width="100"
            />

            <el-table-column
                label="当前在用量"
                align="center"
                prop="useNum"
                min-width="180"
            >
            </el-table-column>
            <el-table-column
                label="退料数量"
                align="center"
                prop="createTime"
                min-width="180"
            >
                <template slot-scope="scope">
                    <el-input
                        v-model.number="scope.row.num"
                        placeholder="请输入退料数量"
                        type="number"
                        min="1"
                        clearable
                        @input="checkNum(scope.row)"
                        style="width: 100%"
                    />
                </template>
            </el-table-column>
            <el-table-column
                label="备注"
                align="center"
                prop="remark"
                min-width="180"
            >
                <template slot-scope="scope">
                    <el-input
                        v-model="scope.row.remark"
                        placeholder="请输入备注"
                        clearable
                        style="width: 100%"
                        @keyup.enter.native="handleQuery"
                    />
                </template>
            </el-table-column>
            <el-table-column
                label="操作"
                align="center"
                fixed="right"
                class-name="small-padding fixed-width"
                width="160px"
            >
                <template slot-scope="scope" v-if="scope.row.roleId !== 1">
                    <!--          <el-button-->
                    <!--            size="mini"-->
                    <!--            type="text"-->
                    <!--            icon="el-icon-edit"-->
                    <!--            @click="handleBack(scope.row)"-->
                    <!--            v-hasPermi="['system:role:edit']"-->
                    <!--          >修改</el-button>-->
                    <el-button
                        size="mini"
                        type="text"
                        icon="el-icon-delete"
                        @click="
                            handleDelete({ ...scope.row, index: scope.$index })
                        "
                        >删除</el-button
                    >
                </template>
            </el-table-column>
        </el-table>
    </div>
</template>

<script>
import {
    getRole,
    delRole,
    addRole,
    updateRole,
    dataScope,
    changeRoleStatus,
    deptTreeSelect,
} from '@/api/system/role'
import {
    treeselect as menuTreeselect,
    roleMenuTreeselect,
} from '@/api/system/menu'
import {
    getProData,
    getUnitData,
    getDeviceTypeTree,
    getAgreementInfoById,
    submitLeaseApply,
    getUseTypeTreee,
    getUseNumByTypeId,
} from '@/api/claimAndRefund/receive'
import { submitBackApplyApi } from '@/api/claimAndRefund/return'
import {
    submitBackApplyApiByCq,
    materialReturnNoteByApply,
    submitRefuseBackApply,
} from '@/api/claimAndRefund/return.js'
import { mapState } from 'vuex'
import { getInfo, h } from '@/api/login'
export default {
    name: 'ReturnApplyAdd',
    props: {
        rejectId: {
            type: [String, Number],
        },
        agreementId: {
            type: [String, Number],
        },
        isEdit: {
            type: Boolean,
        },
    },
    data() {
        const validatePhone = (rule, value, callback) => {
            const reg = /^[1][3-9][0-9]{9}$/
            if (!reg.test(value)) {
                this.queryParams.phone = ''
            } else {
                callback()
            }
        }
        return {
            // 遮罩层
            loading: false,
            // 选中数组
            ids: [],
            // 非单个禁用
            single: true,
            // 非多个禁用
            multiple: true,
            // 显示搜索条件
            showSearch: true,
            // 总条数
            total: 0,
            // 角色表格数据
            roleList: [],
            // 弹出层标题
            title: '',
            // 是否显示弹出层
            open: false,
            // 是否显示弹出层（数据权限）
            openDataScope: false,
            menuExpand: false,
            menuNodeAll: false,
            deptExpand: true,
            deptNodeAll: false,
            // 日期范围
            dateRange: [],
            // 数据范围选项
            dataScopeOptions: [
                {
                    value: '1',
                    label: '全部数据权限',
                },
                {
                    value: '2',
                    label: '自定数据权限',
                },
                {
                    value: '3',
                    label: '本部门数据权限',
                },
                {
                    value: '4',
                    label: '本部门及以下数据权限',
                },
                {
                    value: '5',
                    label: '仅本人数据权限',
                },
            ],
            // 菜单列表
            menuOptions: [],
            // 部门列表
            deptOptions: [],
            // 查询参数
            queryParams: {
                types: 2,

                unitId: null,
                proId: null,
                agreementId: null, //协议id
                agreementCode: null, //协议code
                companyId: '', //登录信息中取
                createBy: '', //用户名
                taskType: 29,
                taskStatus: 30,
                backTime: '', //申请时间
                //退料人信息
                leaseApplyInfo: {
                    backPerson: '',
                    phone: '',
                    remark: '',
                },
                //退料详情集合
                leaseApplyDetails: [],
            },
            leaseApplyDetails: [],
            //退料详情单条模板
            leaseApplyDetailsItem: {
                createBy: null,
                companyId: null,
                status: 0,
                typeId: null, //  树结构第4级   规格id
                typeName: '', //显示的设备类型
                typeCode: '', //显示的设备规格
                unitNames: '', //显示的设备 单位
                useNum: '', //当前在用量
                remark: '', //单条备注
                preNum: 1, //预领数量
            },
            //
            queryRules: {
                unitId: [
                    {
                        required: true,
                        message: '请选择退料单位',
                        trigger: 'change',
                        type: 'number',
                    },
                ],
                proId: [
                    {
                        required: true,
                        message: '请选择退料工程',
                        trigger: 'change',
                        type: 'number',
                    },
                ],
                backPerson: [
                    {
                        required: true,
                        message: '请输入退料人',
                        trigger: 'blur',
                    },
                ],
                backTime: [
                    {
                        required: true,
                        message: '请选择退料时间',
                        trigger: 'change',
                    },
                ],
                phone: [
                    {
                        required: true,
                        trigger: 'blur',
                        message: '请输入退料人的手机号',
                    },
                    {
                        pattern: /^1[3456789]\d{9}$/,
                        message: '请输入正确的手机号码',
                        trigger: 'blur',
                    },
                ],
                // phone: [
                //   { validator: validatePhone, trigger: "blur"},
                //   {required: true, message: '请输入正确的手机号', trigger: 'change'},
                // ],
            },
            unitList: [], //单位 集合
            proList: [], // 工程 集合
            deviceTypeTree: [], // 设备 树结构数据
            // 设备 树显示 配置
            deviceTypeTreeProps: {
                children: 'children',
                label: 'typeName',
                // multiple: false,
                value: 'typeId',
            },
            // 选中的设备类型
            deviceType: null,

            // 表单参数
            form: {},
            // defaultProps: {
            //   children: "children",
            //   label: "label"
            // },
            // 表单校验
            rules: {
                roleName: [
                    {
                        required: true,
                        message: '角色名称不能为空',
                        trigger: 'blur',
                    },
                ],
                roleKey: [
                    {
                        required: true,
                        message: '权限字符不能为空',
                        trigger: 'blur',
                    },
                ],
                roleSort: [
                    {
                        required: true,
                        message: '角色顺序不能为空',
                        trigger: 'blur',
                    },
                ],
            },
            companyId: '',
            createBy: '',
            isEdit: 'true',
            rowId: '',
        }
    },
    mounted() {
        this.GetUnitData()
        this.GetProData()
        // this.GetDeviceTypeTreeFn()
        // this.getList();
        // console.log('this.$route.query.isEdit', this.$route.query.isEdit)
        // this.isEdit = this.$route.query.isEdit
        // if (this.$route.query.Id) {
        //     this.rowId = this.$route.query.Id
        //     this.GetViewByApply(this.$route.query.Id)
        // }
        if (this.rejectId) {
            this.rowId = this.rejectId
            this.GetViewByApply({
                id: this.rejectId,
                agreementId: this.agreementId,
            })
        }
        getInfo().then((res) => {
            this.companyId = res.user.companyId
            this.createBy = res.user.userName
        })
    },
    computed: {
        ...mapState(['user']),
    },
    methods: {
        // 获取 来往单位 列表数据
        async GetUnitData() {
            const params = {
                id: this.queryParams.proId /*  */,
            }
            const res = await getUnitData(params)
            this.unitList = res.data

            this.GetAgreementInfoById()
        },
        // 获取 工程名称 列表数据
        async GetProData() {
            const params = {
                id: this.queryParams.unitId,
            }
            const res = await getProData(params)
            this.proList = res.data
            this.GetAgreementInfoById()
        },

        // 获取 设备树结构数据
        async GetDeviceTypeTreeFn(agreementId) {
            const params = {
                agreementId: agreementId,
                //  this.agreementId
            }

            const res = await getUseTypeTreee(params)
            console.log('resgetUseTypeTreee==========', res)
            this.deviceTypeTree = res.data
        },
        // 获取 协议id
        async GetAgreementInfoById() {
            if (this.queryParams.unitId && this.queryParams.proId) {
                const params = {
                    unitId: this.queryParams.unitId,
                    projectId: this.queryParams.proId,
                }
                const res = await getAgreementInfoById(params)
                if (!(res.data && res.data.agreementId)) {
                    this.$message.error('当前单位和工程未上传')
                    this.queryParams.unitId = null
                    this.queryParams.proId = null
                    this.GetUnitData()
                    this.GetProData()
                } else {
                    this.queryParams.agreementId = res.data.agreementId
                    this.queryParams.agreementCode = res.data.agreementCode
                    this.GetDeviceTypeTreeFn(res.data.agreementId)
                }
            }
        },

        // 获取 任务详情数据
        async GetViewByApply(params) {
            const res = await materialReturnNoteByApply({
                id: params.id,
                agreementId: params.agreementId,
            })
            const data = res.data[0]
            // console.log(data)
            // this.queryParams.taskId = data.taskId
            this.queryParams.unitId = data.unitId
            this.queryParams.proId = Number(data.proId)
            this.$set(this.queryParams, 'phone', data.phone)
            this.queryParams.backPerson = data.backPerson
            this.queryParams.backTime = data.backTime
            this.queryParams.agreementCode = data.agreementCode
            this.queryParams.agreementId = data.agreementId
            this.queryParams.remark = data.remark
            this.leaseApplyDetails = res.data
            this.GetDeviceTypeTreeFn(data.agreementId)
        },
        //生成回显数据
        handelEchoData(item) {
            console.log('item======', item)
            const template = JSON.parse(
                JSON.stringify(this.leaseApplyDetailsItem),
            )
            template.createBy = item.createBy
            template.parentId = item.data.parentId
            template.typeId = item.data.typeId
            template.companyId = item.companyId
            // template.typeId = item.typeId
            template.unitNames = item.unitNames
            template.typeCn = item.typeName
            template.guigeCn = item.typeModelName
            template.remark = item.remark
            template.preNum = item.preNum
            template.status = item.status
            return template
        },

        /** 查询角色列表 */
        async getList() {},
        /** 查询菜单树结构 */
        getMenuTreeselect() {
            menuTreeselect().then((response) => {
                this.menuOptions = response.data
            })
        },
        // 所有菜单节点数据
        getMenuAllCheckedKeys() {
            // 目前被选中的菜单节点
            let checkedKeys = this.$refs.menu.getCheckedKeys()
            // 半选中的菜单节点
            let halfCheckedKeys = this.$refs.menu.getHalfCheckedKeys()
            checkedKeys.unshift.apply(checkedKeys, halfCheckedKeys)
            return checkedKeys
        },
        // 所有部门节点数据
        getDeptAllCheckedKeys() {
            // 目前被选中的部门节点
            let checkedKeys = this.$refs.dept.getCheckedKeys()
            // 半选中的部门节点
            let halfCheckedKeys = this.$refs.dept.getHalfCheckedKeys()
            checkedKeys.unshift.apply(checkedKeys, halfCheckedKeys)
            return checkedKeys
        },
        /** 根据角色ID查询菜单树结构 */
        getRoleMenuTreeselect(roleId) {
            return roleMenuTreeselect(roleId).then((response) => {
                this.menuOptions = response.menus
                return response
            })
        },
        /** 根据角色ID查询部门树结构 */
        getDeptTree(roleId) {
            return deptTreeSelect(roleId).then((response) => {
                this.deptOptions = response.depts
                return response
            })
        },
        // 角色状态修改

        // 取消按钮
        cancel() {
            this.open = false
            this.reset()
        },
        // 取消按钮（数据权限）
        cancelDataScope() {
            this.openDataScope = false
            this.reset()
        },
        // 表单重置
        reset() {
            if (this.$refs.menu != undefined) {
                this.$refs.menu.setCheckedKeys([])
            }
            ;(this.menuExpand = false),
                (this.menuNodeAll = false),
                (this.deptExpand = true),
                (this.deptNodeAll = false),
                (this.form = {
                    roleId: undefined,
                    roleName: undefined,
                    roleKey: undefined,
                    roleSort: 0,
                    status: '0',
                    menuIds: [],
                    deptIds: [],
                    menuCheckStrictly: true,
                    deptCheckStrictly: true,
                    remark: undefined,
                })
            this.resetForm('form')
        },
        /** 搜索按钮操作 */
        handleQuery() {
            this.queryParams.pageNum = 1
            this.getList()
        },
        /** 重置按钮操作 */
        resetQuery() {
            this.dateRange = []
            this.resetForm('queryForm')
            this.handleQuery()
        },
        //是否可用勾选框
        selectable(row) {
            console.log(row)
            if (row.num != 0) {
                return true
            } else {
                return false
            }
        },
        // 多选框选中数据
        handleSelectionChange(selection) {
            this.queryParams.leaseApplyDetails = selection
        },
        // 更多操作触发
        handleCommand(command, row) {
            switch (command) {
                case 'handleDataScope':
                    this.handleDataScope(row)
                    break
                case 'handleAuthUser':
                    this.handleAuthUser(row)
                    break
                default:
                    break
            }
        },

        /** 保存按钮操作 */
        handleAdd() {
            this.$refs.queryForm.validate(async (valid) => {
                if (!valid) {
                    return false
                } else {
                    let backApplyInfo = []
                    if (this.queryParams.leaseApplyDetails.length == 0) {
                        this.$message.error('请添加数据')
                        return
                    }
                    // const isRemark = this.queryParams.leaseApplyDetails.some(
                    //   (item) => item.remark == '' || item.remark == undefined
                    // );
                    const isNum = this.queryParams.leaseApplyDetails.some(
                        (item) => item.num == '' || item.num == undefined,
                    )
                    if (isNum) {
                        this.$message.error('退料数量不能为空！')
                        return
                    }

                    this.queryParams.createBy = this.user.name
                    this.queryParams.companyId = this.companyId
                    this.queryParams.backApplyInfo = {
                        backPerson: this.queryParams.backPerson,
                        phone: this.queryParams.phone,
                        remark: this.queryParams.remark,
                        backTime: this.queryParams.backTime,
                        companyId: this.companyId,
                    }
                    if (this.rowId != '') {
                        let params = {
                            companyId: this.companyId,
                            createBy: this.createBy,
                            id: this.rowId,
                            agreementId: this.queryParams.agreementId,
                            backApplyInfo: this.queryParams.backApplyInfo,
                            backApplyDetails:
                                this.queryParams.leaseApplyDetails,
                        }
                        const res = await submitRefuseBackApply(params)
                        if (res.code == 200) {
                            this.$message({ type: 'success', message: res.msg })
                            setTimeout(() => {
                                this.$emit('goBackPage')
                                // this.$tab.closeOpenPage({
                                //     path: '/claimAndRefund/return/returnApplyByCq',
                                // })
                            }, 1000)
                        }
                    } else {
                        let params = {
                            companyId: this.companyId,
                            createBy: this.createBy,
                            agreementId: this.queryParams.agreementId,
                            backApplyInfo: this.queryParams.backApplyInfo,
                            backApplyDetails:
                                this.queryParams.leaseApplyDetails,
                        }
                        const res = await submitBackApplyApi(params)
                        if (res.code == 200) {
                            this.$message({ type: 'success', message: res.msg })
                            setTimeout(() => {
                                this.$emit('goBackPage')
                                // this.$tab.closeOpenPage({
                                //     path: '/claimAndRefund/return/returnApplyByCq',
                                // })
                            }, 1000)
                        }
                    }
                }
            })
        },
        /** 修改按钮操作 */
        handleBack(row) {
            this.$tab.closeOpenPage({
                path: '/claimAndRefund/return/returnApplyByCq',
            })
        },

        /** 分配数据权限操作 */
        handleDataScope(row) {
            this.reset()
            const deptTreeSelect = this.getDeptTree(row.roleId)
            getRole(row.roleId).then((response) => {
                this.form = response.data
                this.openDataScope = true
                this.$nextTick(() => {
                    deptTreeSelect.then((res) => {
                        this.$refs.dept.setCheckedKeys(res.checkedKeys)
                    })
                })
                this.title = '分配数据权限'
            })
        },
        /** 分配用户操作 */
        handleAuthUser: function (row) {
            const roleId = row.roleId
            this.$router.push('/system/role-auth/user/' + roleId)
        },
        /** 提交按钮 */
        submitForm: function () {
            this.$refs['form'].validate((valid) => {
                if (valid) {
                    if (this.form.roleId != undefined) {
                        this.form.menuIds = this.getMenuAllCheckedKeys()
                        updateRole(this.form).then((response) => {
                            this.$modal.msgSuccess('修改成功')
                            this.open = false
                            this.getList()
                        })
                    } else {
                        this.form.menuIds = this.getMenuAllCheckedKeys()
                        addRole(this.form).then((response) => {
                            this.$modal.msgSuccess('新增成功')
                            this.open = false
                            this.getList()
                        })
                    }
                }
            })
        },

        /** 删除按钮操作 */
        handleDelete(row) {
            this.leaseApplyDetails.splice(row.index, 1)
        },
        /** 导出按钮操作 */
        handleExport() {
            this.download(
                'system/role/export',
                {
                    ...this.queryParams,
                },
                `role_${new Date().getTime()}.xlsx`,
            )
        },

        checkNum(row) {
            let maxNum = row.useNum
            if (row.num <= 1) {
                row.num = 1
            } else if (row.num >= maxNum) {
                row.num = maxNum
            }
        },

        /////// 设备类型树  切换
        async deviceTypeChange(val) {
            let nodes = null
            console.log(
                'vall1211221122',
                this.$refs.deviceTypeCascader.getCheckedNodes().length,
                this.$refs.deviceTypeCascader.getCheckedNodes(),
                [this.$refs.deviceTypeCascader.panel.getNodeByValue(val)],
            )
            nodes =
                this.$refs.deviceTypeCascader.getCheckedNodes().length > 0
                    ? this.$refs.deviceTypeCascader.getCheckedNodes()
                    : [this.$refs.deviceTypeCascader.panel.getNodeByValue(val)]
            console.log('nodes', nodes)
            // const res = await getUseNumByTypeId({ typeId: nodes[0].data.typeId })
            nodes[0].data.useNum = nodes[0].data.num
            if (nodes[0].level != 4) {
                return
            }
            if (nodes[0].data.useNum < 1) {
                this.$modal.msgError('所选机具类型当前无在用!')
                return
            }
            for (let i = 0; i < this.leaseApplyDetails.length; i++) {
                if (this.leaseApplyDetails[i].typeId == nodes[0].data.typeId) {
                    this.leaseApplyDetails.splice(i, 1)
                    break
                }
            }
            this.leaseApplyDetails.push(this.handelTableItemData(nodes[0]))
            // this.$refs.cascader.$refs.panel.clearCheckedNodes()
            // // 设置为空可以让节点不高亮显示
            // this.$refs.cascader.$refs.panel.activePath = []
            this.deviceType = {}
        },
        //// 将数据处理成 表格中需要的数据
        handelTableItemData(node) {
            const template = JSON.parse(
                JSON.stringify(this.leaseApplyDetailsItem),
            )
            template.createBy = this.createBy
            template.typeId = node.data.typeId
            template.companyId = node.data.companyId
            // template.typeId = node.data.id
            template.unitNames = node.data.unitNames
            template.preNum = node.data.num
            template.typeName = node.pathLabels[2]
            template.typeCode = node.pathLabels[3]
            template.num = node.data.num
            template.useNum = node.data.useNum
            return template
        },
    },
}
</script>
